# Generated by the protocol buffer compiler.  DO NOT EDIT!
# sources: nillion/permissions/v1/update.proto
# plugin: python-betterproto
# This file has been @generated

from dataclasses import dataclass
from typing import List

import betterproto


@dataclass(eq=False, repr=False)
class UpdatePermissionsRequest(betterproto.Message):
    """
    A request to update the permissions on a set of values to another user.

     Any `revoke_*` permissions only have an effect if the user id provided already had
     that permission before. e.g. using `revoke_retrieve` for a user id that doesn't have
     retrieve permissions has no effect.
    """

    signed_receipt: "___payments_v1_receipt__.SignedReceipt" = (
        betterproto.message_field(1)
    )
    """
    The receipt that proves this operation was paid for.
    
     The receipt must be for a `UpdatePermissions` operation.
    """

    retrieve: "PermissionCommand" = betterproto.message_field(2)
    """The retrieve values permissions to be granted/revoked."""

    update: "PermissionCommand" = betterproto.message_field(3)
    """The update values permissions to be granted/revoked."""

    delete: "PermissionCommand" = betterproto.message_field(4)
    """The delete values permissions to be granted/revoked."""

    compute: "ComputePermissionCommand" = betterproto.message_field(5)
    """The compute permissions to be granted/revoked."""


@dataclass(eq=False, repr=False)
class PermissionCommand(betterproto.Message):
    """
    The set of users that are being granted/revoke permissions for an action.
    """

    grant: List["___auth_v1_user__.UserId"] = betterproto.message_field(1)
    """The list of users that we're granting permissions to."""

    revoke: List["___auth_v1_user__.UserId"] = betterproto.message_field(2)
    """The list of users that we're revoking permissions from."""


@dataclass(eq=False, repr=False)
class ComputePermissionCommand(betterproto.Message):
    """
    The set of users that are being granted/revoke permissions for compute actions.
    """

    grant: List["_permissions__.ComputePermissions"] = betterproto.message_field(1)
    """The user ids that will be allowed to compute on the stored values."""

    revoke: List["_permissions__.ComputePermissions"] = betterproto.message_field(2)
    """
    The user ids that will be revoked the permission to compute the stored values.
    """


from ....auth.v1 import user as ___auth_v1_user__
from ....payments.v1 import receipt as ___payments_v1_receipt__
from .. import permissions as _permissions__
